echo off

set RHAP_JARS_DIR=C:/Program Files/IBM/Rational/Rhapsody/7.5/Share\LangJava\lib
set FRAMEWORK_NONE_JARS=C:/Program Files/IBM/Rational/Rhapsody/7.5/Share\LangJava\lib\oxf.jar;C:/Program Files/IBM/Rational/Rhapsody/7.5/Share\LangJava\lib\anim.jar;C:/Program Files/IBM/Rational/Rhapsody/7.5/Share\LangJava\lib\animcom.jar;C:/Program Files/IBM/Rational/Rhapsody/7.5/Share\LangJava\lib\oxfInstMock.jar;
set FRAMEWORK_ANIM_JARS=C:/Program Files/IBM/Rational/Rhapsody/7.5/Share\LangJava\lib\oxf.jar;C:/Program Files/IBM/Rational/Rhapsody/7.5/Share\LangJava\lib\anim.jar;C:/Program Files/IBM/Rational/Rhapsody/7.5/Share\LangJava\lib\animcom.jar;C:/Program Files/IBM/Rational/Rhapsody/7.5/Share\LangJava\lib\oxfInst.jar;
set SOURCEPATH=%SOURCEPATH%
set CLASSPATH=%CLASSPATH%;.
set PATH=%RHAP_JARS_DIR%;%PATH%;
set INSTRUMENTATION=Animation   

set BUILDSET=Debug

if %INSTRUMENTATION%==Animation goto anim

:noanim
set CLASSPATH=%CLASSPATH%;%FRAMEWORK_NONE_JARS%
goto setEnv_end

:anim
set CLASSPATH=%CLASSPATH%;%FRAMEWORK_ANIM_JARS%

:setEnv_end

if "%1" == "" goto compile
if "%1" == "build" goto compile
if "%1" == "clean" goto clean
if "%1" == "rebuild" goto clean
if "%1" == "run" goto run

:clean
echo cleaning class files
if exist Default\OffresIntegreesServeur.class del Default\OffresIntegreesServeur.class
if exist Default\ConnexionFournisseur.class del Default\ConnexionFournisseur.class
if exist Default\OffresIntegrees.class del Default\OffresIntegrees.class
if exist Default\OffresFournisseur.class del Default\OffresFournisseur.class
if exist Default\ConnexionUser.class del Default\ConnexionUser.class
if exist MainDefaultComponent.class del MainDefaultComponent.class
if exist Default\DemandeInfo.class del Default\DemandeInfo.class
if exist Default\go.class del Default\go.class
if exist Default\Serveur.class del Default\Serveur.class
if exist Default\AffichageResultats.class del Default\AffichageResultats.class
if exist Default\DemandeOffresFournisseur.class del Default\DemandeOffresFournisseur.class
if exist Default\Default_pkgClass.class del Default\Default_pkgClass.class
if exist Default\goFournisseurs.class del Default\goFournisseurs.class
if exist Default\IntegrationOffresFournisseur.class del Default\IntegrationOffresFournisseur.class
if exist Default\User.class del Default\User.class
if exist Default\ProduitsAdaptes.class del Default\ProduitsAdaptes.class
if exist Default\DemandeProduitsAdaptes.class del Default\DemandeProduitsAdaptes.class
if exist Default\InfosUtilisateur.class del Default\InfosUtilisateur.class
if exist Default\Fournisseurs.class del Default\Fournisseurs.class
if exist Default\Y_activity.class del Default\Y_activity.class

if "%1" == "clean" goto end

:compile   
if %BUILDSET%==Debug goto compile_debug
echo compiling JAVA source files
javac  @files.lst
goto end

:compile_debug
echo compiling JAVA source files
javac -g  @files.lst
goto end

:run

java %2

:end


