/*********************************************************************
	Rhapsody in C	: 7.5 
	Login		: Admin
	Component	: DefaultComponent 
	Configuration 	: DefaultConfig
	Model Element	: User
//!	Generated Date	: Thu, 5, Dec 2013  
	File Path	: DefaultComponent\DefaultConfig\User.c
*********************************************************************/

/*## auto_generated */
#include "User.h"
/*## link itsY_activity */
#include "Y_activity.h"
/*#[ ignore */
#define Default_User_User_SERIALIZE OM_NO_OP
/*#]*/

/*## package Default */

/*## actor User */
/*## auto_generated */
static void initStatechart(User* const me);

/*## auto_generated */
static void cleanUpRelations(User* const me);

#ifdef _OMINSTRUMENT
static void serializeRelations(const void * const void_me, ARCSRelations * arcsRelations);

/*## statechart_method */
static void rootState_serializeStates(const void * const void_me, ARCSState * arcsState);
#endif /* _OMINSTRUMENT */

/*## statechart_method */
static void rootState_entDef(void * const void_me);

/*## statechart_method */
static RiCTakeEventStatus rootState_dispatchEvent(void * const void_me, short id);

#ifdef _OMINSTRUMENT
/*## statechart_method */
static void wait_resultats_serializeStates(const User* const me, ARCSState * arcsState);

/*## statechart_method */
static void wait_demande_info_serializeStates(const User* const me, ARCSState * arcsState);

/*## statechart_method */
static void wait_serializeStates(const User* const me, ARCSState * arcsState);
#endif /* _OMINSTRUMENT */

/*#[ ignore */
static void FreeInstance(User* const me);

static const ARCSerCVtbl Default_User_instrumentVtbl = {
    NULL,
    serializeRelations
};
/*#]*/

#ifdef _OMINSTRUMENT
OM_INSTRUMENT_OBJECT_TYPE(User, Default, Default, FALSE, &Default_User_instrumentVtbl)
#endif /* _OMINSTRUMENT */

void User_Init(User* const me, RiCTask * p_task) {
    /* Virtual tables Initialization */
    static const RiCReactive_Vtbl User_reactiveVtbl = {
        rootState_dispatchEvent,
        rootState_entDef,
        ROOT_STATE_SERIALIZE_STATES(rootState_serializeStates),
        (RiCObjectDestroyMethod) User_Destroy,
        NULL,
        NULL,
        NULL,
        (RiCObjectCleanupMethod) User_Cleanup,
        (RiCObjectFreeMethod) FreeInstance
    };
    RiCReactive_init(&(me->ric_reactive), (void*)me, p_task, &User_reactiveVtbl);
    NOTIFY_REACTIVE_CONSTRUCTOR(me, &me, NULL, User, User_Init, User_Init(), 0, Default_User_User_SERIALIZE);
    RiCReactive_setActive(&(me->ric_reactive), RiCFALSE);
    me->itsY_activity = NULL;
    initStatechart(me);
    NOTIFY_END_CONSTRUCTOR(me);
}

void User_Cleanup(User* const me) {
    NOTIFY_DESTRUCTOR(me, &me, User, ~User);
    RiCReactive_cleanup(&(me->ric_reactive));
    cleanUpRelations(me);
}

struct Y_activity* User_getItsY_activity(const User* const me) {
    return (struct Y_activity*)me->itsY_activity;
}

void User_setItsY_activity(User* const me, struct Y_activity* p_Y_activity) {
    if(p_Y_activity != NULL)
        {
            Y_activity__setItsUser(p_Y_activity, me);
        }
    User__setItsY_activity(me, p_Y_activity);
}

User * User_Create(RiCTask * p_task) {
    User* me = (User *) malloc(sizeof(User));
    if(me!=NULL)
        {
            User_Init(me, p_task);
        }
    DYNAMICALLY_ALLOCATED(me);
    return me;
}

void User_Destroy(User* const me) {
    if(me!=NULL)
        {
            User_Cleanup(me);
        }
    free(me);
}

RiCBoolean User_startBehavior(User* const me) {
    RiCBoolean done = RiCFALSE;
    done = RiCReactive_startBehavior(&(me->ric_reactive));
    return done;
}

static void initStatechart(User* const me) {
    me->rootState_subState = User_RiCNonState;
    me->rootState_active = User_RiCNonState;
}

static void cleanUpRelations(User* const me) {
    if(me->itsY_activity != NULL)
        {
            NOTIFY_RELATION_CLEARED(me, User, "itsY_activity");
            {
                struct User* p_User = Y_activity_getItsUser(me->itsY_activity);
                if(p_User != NULL)
                    {
                        Y_activity___setItsUser(me->itsY_activity, NULL);
                    }
                me->itsY_activity = NULL;
            }
        }
}

void User___setItsY_activity(User* const me, struct Y_activity* p_Y_activity) {
    me->itsY_activity = p_Y_activity;
    if(p_Y_activity != NULL)
        {
            NOTIFY_RELATION_ITEM_ADDED(me, User, Y_activity, "itsY_activity", p_Y_activity, FALSE, TRUE);
        }
    else
        {
            NOTIFY_RELATION_CLEARED(me, User, "itsY_activity");
        }
}

void User__setItsY_activity(User* const me, struct Y_activity* p_Y_activity) {
    if(me->itsY_activity != NULL)
        {
            Y_activity___setItsUser(me->itsY_activity, NULL);
        }
    User___setItsY_activity(me, p_Y_activity);
}

void User__clearItsY_activity(User* const me) {
    NOTIFY_RELATION_CLEARED(me, User, "itsY_activity");
    me->itsY_activity = NULL;
}

int User_rootState_IN(const User* const me) {
    return 1;
}

int User_wait_resultats_IN(const User* const me) {
    return me->rootState_subState == User_wait_resultats;
}

int User_wait_demande_info_IN(const User* const me) {
    return me->rootState_subState == User_wait_demande_info;
}

int User_wait_IN(const User* const me) {
    return me->rootState_subState == User_wait;
}

#ifdef _OMINSTRUMENT
static void serializeRelations(const void * const void_me, ARCSRelations * arcsRelations) {
    
    const User * const me = (const User *)void_me;
    ARCSRS_addRelation(arcsRelations, "itsY_activity", FALSE, TRUE);
    if(me->itsY_activity)
        {
            ARCSRS_addItem(arcsRelations, Y_activity, me->itsY_activity);
        }
}

static void rootState_serializeStates(const void * const void_me, ARCSState * arcsState) {
    
    const User * const me = (const User *)void_me;
    ARCSS_addState_OMH(arcsState, "ROOT");
    switch (me->rootState_subState) {
        case User_wait:
        {
            wait_serializeStates(me, arcsState);
        }
        break;
        case User_wait_demande_info:
        {
            wait_demande_info_serializeStates(me, arcsState);
        }
        break;
        case User_wait_resultats:
        {
            wait_resultats_serializeStates(me, arcsState);
        }
        break;
        default:
            break;
    }
}
#endif /* _OMINSTRUMENT */

static void rootState_entDef(void * const void_me) {
    
    User * const me = (User *)void_me;
    {
        NOTIFY_STATE_ENTERED(me, User, "ROOT");
        NOTIFY_TRANSITION_STARTED(me, User, "0");
        NOTIFY_STATE_ENTERED(me, User, "ROOT.wait");
        me->rootState_subState = User_wait;
        me->rootState_active = User_wait;
        NOTIFY_TRANSITION_TERMINATED(me, User, "0");
    }
}

static RiCTakeEventStatus rootState_dispatchEvent(void * const void_me, short id) {
    
    User * const me = (User *)void_me;
    RiCTakeEventStatus res = eventNotConsumed;
    switch (me->rootState_active) {
        case User_wait:
        {
            if(id == go_Default_id)
                {
                    NOTIFY_TRANSITION_STARTED(me, User, "1");
                    NOTIFY_STATE_EXITED(me, User, "ROOT.wait");
                    {
                        /*#[ transition 1 */
                        itsUser->gen(new ConnexionUser());
                        /*#]*/
                    }
                    NOTIFY_STATE_ENTERED(me, User, "ROOT.wait_demande_info");
                    me->rootState_subState = User_wait_demande_info;
                    me->rootState_active = User_wait_demande_info;
                    NOTIFY_TRANSITION_TERMINATED(me, User, "1");
                    res = eventConsumed;
                }
        }
        break;
        case User_wait_demande_info:
        {
            if(id == DemandeInfo_Default_id)
                {
                    NOTIFY_TRANSITION_STARTED(me, User, "2");
                    NOTIFY_STATE_EXITED(me, User, "ROOT.wait_demande_info");
                    {
                        /*#[ transition 2 */
                        itsUser->gen(new InfosUtilisateur());
                        /*#]*/
                    }
                    NOTIFY_STATE_ENTERED(me, User, "ROOT.wait_resultats");
                    me->rootState_subState = User_wait_resultats;
                    me->rootState_active = User_wait_resultats;
                    NOTIFY_TRANSITION_TERMINATED(me, User, "2");
                    res = eventConsumed;
                }
        }
        break;
        case User_wait_resultats:
        {
            if(id == AffichageResultats_Default_id)
                {
                    NOTIFY_TRANSITION_STARTED(me, User, "3");
                    NOTIFY_STATE_EXITED(me, User, "ROOT.wait_resultats");
                    NOTIFY_STATE_ENTERED(me, User, "ROOT.wait");
                    me->rootState_subState = User_wait;
                    me->rootState_active = User_wait;
                    NOTIFY_TRANSITION_TERMINATED(me, User, "3");
                    res = eventConsumed;
                }
        }
        break;
        default:
            break;
    }
    return res;
}

#ifdef _OMINSTRUMENT
static void wait_resultats_serializeStates(const User* const me, ARCSState * arcsState) {
    ARCSS_addState_OMH(arcsState, "ROOT.wait_resultats");
}

static void wait_demande_info_serializeStates(const User* const me, ARCSState * arcsState) {
    ARCSS_addState_OMH(arcsState, "ROOT.wait_demande_info");
}

static void wait_serializeStates(const User* const me, ARCSState * arcsState) {
    ARCSS_addState_OMH(arcsState, "ROOT.wait");
}
#endif /* _OMINSTRUMENT */

/*#[ ignore */
static void FreeInstance(User* const me) {
    free(me);
}
/*#]*/

/*********************************************************************
	File Path	: DefaultComponent\DefaultConfig\User.c
*********************************************************************/
