/*********************************************************************
	Rhapsody in C	: 7.5 
	Login		: Admin
	Component	: DefaultComponent 
	Configuration 	: DefaultConfig
	Model Element	: Y_activity
//!	Generated Date	: Thu, 5, Dec 2013  
	File Path	: DefaultComponent\DefaultConfig\Y_activity.c
*********************************************************************/

/*## auto_generated */
#include "Y_activity.h"
/*## link itsFournisseurs */
#include "Fournisseurs.h"
/*## link itsServeur */
#include "Serveur.h"
/*## link itsUser */
#include "User.h"
/*#[ ignore */
#define Default_Y_activity_Y_activity_SERIALIZE OM_NO_OP
/*#]*/

/*## package Default */

/*## class Y_activity */
/*## auto_generated */
static void cleanUpRelations(Y_activity* const me);

#ifdef _OMINSTRUMENT
static void serializeRelations(const void * const void_me, ARCSRelations * arcsRelations);
#endif /* _OMINSTRUMENT */

/*#[ ignore */
static void FreeInstance(Y_activity* const me);

static const ARCSerCVtbl Default_Y_activity_instrumentVtbl = {
    NULL,
    serializeRelations
};
/*#]*/

#ifdef _OMINSTRUMENT
OM_INSTRUMENT_OBJECT_TYPE(Y_activity, Default, Default, FALSE, &Default_Y_activity_instrumentVtbl)
#endif /* _OMINSTRUMENT */

void Y_activity_Init(Y_activity* const me, RiCTask * p_task) {
    /* Virtual tables Initialization */
    static const RiCReactive_Vtbl Y_activity_reactiveVtbl = {
        NULL,
        NULL,
        NULL,
        (RiCObjectDestroyMethod) Y_activity_Destroy,
        NULL,
        NULL,
        NULL,
        (RiCObjectCleanupMethod) Y_activity_Cleanup,
        (RiCObjectFreeMethod) FreeInstance
    };
    RiCReactive_init(&(me->ric_reactive), (void*)me, p_task, &Y_activity_reactiveVtbl);
    NOTIFY_REACTIVE_CONSTRUCTOR(me, &me, NULL, Y_activity, Y_activity_Init, Y_activity_Init(), 0, Default_Y_activity_Y_activity_SERIALIZE);
    RiCCollection_Init(&(me->itsFournisseurs), RiC_DEFAULT_START_SIZE);
    RiCReactive_setActive(&(me->ric_reactive), RiCFALSE);
    me->itsServeur = NULL;
    me->itsUser = NULL;
    NOTIFY_END_CONSTRUCTOR(me);
}

void Y_activity_Cleanup(Y_activity* const me) {
    NOTIFY_DESTRUCTOR(me, &me, Y_activity, ~Y_activity);
    RiCReactive_cleanup(&(me->ric_reactive));
    cleanUpRelations(me);
}

RiCCollection * Y_activity_getItsFournisseurs(const Y_activity* const me) {
    unsigned pos;
    RiCCollection * iter = (RiCCollection *) &(me->itsFournisseurs);
    RiCCollection_first(iter, &pos);
    return iter;
}

void Y_activity_addItsFournisseurs(Y_activity* const me, struct Fournisseurs* p_Fournisseurs) {
    if(p_Fournisseurs != NULL)
        {
            Fournisseurs__setItsY_activity(p_Fournisseurs, me);
        }
    Y_activity__addItsFournisseurs(me, p_Fournisseurs);
}

void Y_activity_removeItsFournisseurs(Y_activity* const me, struct Fournisseurs* p_Fournisseurs) {
    if(p_Fournisseurs != NULL)
        {
            Fournisseurs___setItsY_activity(p_Fournisseurs, NULL);
        }
    Y_activity__removeItsFournisseurs(me, p_Fournisseurs);
}

void Y_activity_clearItsFournisseurs(Y_activity* const me) {
    unsigned pos;
    RiCCollection * iter = &(me->itsFournisseurs);
    RiCCollection_first(iter, &pos);
    while (!RiCCollection_isDone(iter, pos)){
        Fournisseurs__clearItsY_activity((RiCCollection_get(iter, pos)));
        RiCCollection_next(iter, &pos);
    }
    Y_activity__clearItsFournisseurs(me);
}

struct Serveur* Y_activity_getItsServeur(const Y_activity* const me) {
    return (struct Serveur*)me->itsServeur;
}

void Y_activity_setItsServeur(Y_activity* const me, struct Serveur* p_Serveur) {
    if(p_Serveur != NULL)
        {
            Serveur__setItsY_activity(p_Serveur, me);
        }
    Y_activity__setItsServeur(me, p_Serveur);
}

struct User* Y_activity_getItsUser(const Y_activity* const me) {
    return (struct User*)me->itsUser;
}

void Y_activity_setItsUser(Y_activity* const me, struct User* p_User) {
    if(p_User != NULL)
        {
            User__setItsY_activity(p_User, me);
        }
    Y_activity__setItsUser(me, p_User);
}

Y_activity * Y_activity_Create(RiCTask * p_task) {
    Y_activity* me = (Y_activity *) malloc(sizeof(Y_activity));
    if(me!=NULL)
        {
            Y_activity_Init(me, p_task);
        }
    DYNAMICALLY_ALLOCATED(me);
    return me;
}

void Y_activity_Destroy(Y_activity* const me) {
    if(me!=NULL)
        {
            Y_activity_Cleanup(me);
        }
    free(me);
}

RiCBoolean Y_activity_startBehavior(Y_activity* const me) {
    RiCBoolean done = RiCFALSE;
    done = RiCReactive_startBehavior(&(me->ric_reactive));
    return done;
}

static void cleanUpRelations(Y_activity* const me) {
    {
        unsigned pos;
        RiCCollection * iter = &(me->itsFournisseurs);
        RiCCollection_first(iter, &pos);
        while (!RiCCollection_isDone(iter, pos)){
            struct Y_activity* p_Y_activity = Fournisseurs_getItsY_activity((RiCCollection_get(iter, pos)));
            if(p_Y_activity != NULL)
                {
                    Fournisseurs___setItsY_activity((RiCCollection_get(iter, pos)), NULL);
                }
            RiCCollection_next(iter, &pos);
        }
        RiCCollection_Cleanup(&(me->itsFournisseurs));
    }
    if(me->itsServeur != NULL)
        {
            NOTIFY_RELATION_CLEARED(me, Y_activity, "itsServeur");
            {
                struct Y_activity* p_Y_activity = Serveur_getItsY_activity(me->itsServeur);
                if(p_Y_activity != NULL)
                    {
                        Serveur___setItsY_activity(me->itsServeur, NULL);
                    }
                me->itsServeur = NULL;
            }
        }
    if(me->itsUser != NULL)
        {
            NOTIFY_RELATION_CLEARED(me, Y_activity, "itsUser");
            {
                struct Y_activity* p_Y_activity = User_getItsY_activity(me->itsUser);
                if(p_Y_activity != NULL)
                    {
                        User___setItsY_activity(me->itsUser, NULL);
                    }
                me->itsUser = NULL;
            }
        }
}

void Y_activity__addItsFournisseurs(Y_activity* const me, struct Fournisseurs* p_Fournisseurs) {
    if(p_Fournisseurs != NULL)
        {
            NOTIFY_RELATION_ITEM_ADDED(me, Y_activity, Fournisseurs, "itsFournisseurs", p_Fournisseurs, FALSE, FALSE);
        }
    else
        {
            NOTIFY_RELATION_CLEARED(me, Y_activity, "itsFournisseurs");
        }
    {
        RiCCollection_add(&(me->itsFournisseurs), p_Fournisseurs);
    }
}

void Y_activity__removeItsFournisseurs(Y_activity* const me, struct Fournisseurs* p_Fournisseurs) {
    NOTIFY_RELATION_ITEM_REMOVED(me, Y_activity, Fournisseurs, "itsFournisseurs", p_Fournisseurs);
    {
        RiCCollection_remove(&(me->itsFournisseurs), p_Fournisseurs);
    }
}

void Y_activity__clearItsFournisseurs(Y_activity* const me) {
    NOTIFY_RELATION_CLEARED(me, Y_activity, "itsFournisseurs");
    RiCCollection_removeAll(&(me->itsFournisseurs));
}

void Y_activity___setItsServeur(Y_activity* const me, struct Serveur* p_Serveur) {
    me->itsServeur = p_Serveur;
    if(p_Serveur != NULL)
        {
            NOTIFY_RELATION_ITEM_ADDED(me, Y_activity, Serveur, "itsServeur", p_Serveur, FALSE, TRUE);
        }
    else
        {
            NOTIFY_RELATION_CLEARED(me, Y_activity, "itsServeur");
        }
}

void Y_activity__setItsServeur(Y_activity* const me, struct Serveur* p_Serveur) {
    if(me->itsServeur != NULL)
        {
            Serveur___setItsY_activity(me->itsServeur, NULL);
        }
    Y_activity___setItsServeur(me, p_Serveur);
}

void Y_activity__clearItsServeur(Y_activity* const me) {
    NOTIFY_RELATION_CLEARED(me, Y_activity, "itsServeur");
    me->itsServeur = NULL;
}

void Y_activity___setItsUser(Y_activity* const me, struct User* p_User) {
    me->itsUser = p_User;
    if(p_User != NULL)
        {
            NOTIFY_RELATION_ITEM_ADDED(me, Y_activity, User, "itsUser", p_User, FALSE, TRUE);
        }
    else
        {
            NOTIFY_RELATION_CLEARED(me, Y_activity, "itsUser");
        }
}

void Y_activity__setItsUser(Y_activity* const me, struct User* p_User) {
    if(me->itsUser != NULL)
        {
            User___setItsY_activity(me->itsUser, NULL);
        }
    Y_activity___setItsUser(me, p_User);
}

void Y_activity__clearItsUser(Y_activity* const me) {
    NOTIFY_RELATION_CLEARED(me, Y_activity, "itsUser");
    me->itsUser = NULL;
}

#ifdef _OMINSTRUMENT
static void serializeRelations(const void * const void_me, ARCSRelations * arcsRelations) {
    
    const Y_activity * const me = (const Y_activity *)void_me;
    ARCSRS_addRelation(arcsRelations, "itsUser", FALSE, TRUE);
    if(me->itsUser)
        {
            ARCSRS_addItem(arcsRelations, User, me->itsUser);
        }
    ARCSRS_addRelation(arcsRelations, "itsFournisseurs", FALSE, FALSE);
    {
        unsigned pos;
        RiCCollection * iter = (RiCCollection *) &(me->itsFournisseurs);
        RiCCollection_first(iter, &pos);
        while (!RiCCollection_isDone(iter, pos)){
            ARCSRS_addItem(arcsRelations, Fournisseurs, RiCCollection_get(iter, pos));
            RiCCollection_next(iter, &pos);
        }
    }
    ARCSRS_addRelation(arcsRelations, "itsServeur", FALSE, TRUE);
    if(me->itsServeur)
        {
            ARCSRS_addItem(arcsRelations, Serveur, me->itsServeur);
        }
}
#endif /* _OMINSTRUMENT */

/*#[ ignore */
static void FreeInstance(Y_activity* const me) {
    free(me);
}
/*#]*/

/*********************************************************************
	File Path	: DefaultComponent\DefaultConfig\Y_activity.c
*********************************************************************/
